<template>
<div class="step-box">
  <v-stepper
    v-model="e1"
    alt-labels
  >
    <template>
      <v-stepper-header>
        <template v-for="n in steps">
          <v-stepper-step
            :key="`${n}-step`"
            :complete="e1 > n"
            :step="n"
          >
          </v-stepper-step>
          <v-divider
            v-if="n !== steps"
            :key="n"
          ></v-divider>
        </template>
      </v-stepper-header>
      <v-stepper-items>
        <v-stepper-content
          v-for="n in steps"
          :key="`${n}-content`"
          :step="n"
        >
          <div v-if="n == 1">
            <st-title text="Datos del programa"/>
            <div class="fields">
              <v-text-field 
                v-for="(field, index) in fields"
                v-model="field.value"
                :counter="field.counter"
                :rules="field.rules"
                :label="field.label"
                :key="index"
                required
              />
            </div>
          </div>
          <div v-else>
            <st-title text="Seleccionar coordinador"/>
            <div class="fields">
              <st-search 
                md="12"
                text="Buscar por nombre o código"
                @enter="getItems($event)"
              />
              <st-select-table
                :dataInfo="{ headers,items,key }"
                :loading="loading"
                @selected="enable($event)"
              />
            </div>
          </div>
          <div class="content-footer">
            <st-cancel-btn/>
            <st-primary-btn nombre="Siguiente" @click="nextStep(n)"/>
          </div>
        </v-stepper-content>
      </v-stepper-items>
    </template>
  </v-stepper>
</div>
</template>

<script>
import Search from '@/components/Search'
import SelectTable from '@/components/SelectTable'
export default {
  data () {
    return{
     e1: 1,
      steps: 2,
      idFacultad:'bd3c5af9-76c4-4083-84cf-855071f20865',
      headers: [
        {
          text: 'Nombre',
          align: 'start',
          value: 'nombres',
        },
        { 
          text: 'Código', 
          value: 'codigo' 
        },
        
      ],
      loading: false,
      coordinador:{},
      key: 'idCoordinador',
      items: [],
      fields:{
        codigo:{
          value: '',
          label: 'Código',
          counter: '8', 
          rules: [
            v => !!v || 'El codigo es requerido',
          ],
        },
        nombre:{
          value: '',
          label: 'Nombre',
          counter: '150', 
          rules: [
            v => !!v || 'El nombre es requerido',
          ],
        },
      }
    }
  },
  watch: {
    steps (val) {
      if (this.e1 > val) {
        this.e1 = val
      }
    },
  },
  components: {
    'st-search': Search,
    'st-select-table': SelectTable
  },
  methods:{
    onInput (val) {
      this.steps = parseInt(val)
    },
    nextStep (n) {
      if (n === this.steps) {
        this.e1 = 1
      } else {
        this.e1 = n + 1
      }
    },
    async getItems(search){
        this.loading = true
        let { data: { data } } = await this.$api.getCoordinators(search)
        this.items = data
        this.loading = false
    },
    enable(row){
        this.coordinador=row,
        this.valid=(this.coordinador!=null)
    },
    register(){
      let field = this.fields
      let data = {
        'data': {
            'idFacultad':idFacultad,
            'programa': {
                'codigo':field.codigo.value,
                'nombre': field.nombre.value,
                'idCoordinador':'daa',
            }
        }
      }
      this.valid = false
      this.$api.addCoordinator(data)
      .then( ({ data }) => {
        this.$router.push('/admin/coordinadores')
      })
      .catch(( error ) => {
          this.valid = true
          this.$store.commit("setError", error);
      })
    }
  }
}
</script>

<style scoped lang="scss"> 
/* scope for encapsulate css */
</style>
